## dolfin 2019.2.0~git20200629.946dbd3

=== debian/changelog ===
dolfin (2019.2.0~git20200629.946dbd3-1) unstable; urgency=medium

  * New upstream snapshot.
    - applies debian patch function_MeshView_f0a90b8.diff

 -- Drew Parsons <dparsons@debian.org>  Sun, 06 Sep 2020 00:40:10 +0800

dolfin (2019.2.0~git20200218.027d9cc-18) unstable; urgency=medium

  * debian patch pybind11_lto_mips64el.patch disables LTO linking
    with pybind11 on mips64el (applies -fno-lto when building python
    extensions on mips64el).

 -- Drew Parsons <dparsons@debian.org>  Tue, 01 Sep 2020 17:05:28 +0800

dolfin (2019.2.0~git20200218.027d9cc-17) unstable; urgency=medium

  * swap python3-dolfin Depends/Recommends relationships with
    python3-dolfin[64]-real. Make python3-dolfin primary
    (defaulting to standard 32-bit build)

 -- Drew Parsons <dparsons@debian.org>  Sun, 30 Aug 2020 23:02:47 +0800

dolfin (2019.2.0~git20200218.027d9cc-16) unstable; urgency=medium

  * define petsc64:Depends (PETSc/SLEPc dependencies for libdolfin64-dev)

 -- Drew Parsons <dparsons@debian.org>  Sat, 29 Aug 2020 20:17:07 +0800

dolfin (2019.2.0~git20200218.027d9cc-15) unstable; urgency=medium

  * debian patch lib_rename.patch appends DOLFIN_LIB_NAME_EXT to the
    dolfin library name in DOLFINConfig.cmake, to allow cmake to find
    libdolfin64.so (cmake -DDOLFIN_LIB_NAME_EXT=64) rather than
    libdolfin.so
  * make mathjax handling independent of version

 -- Drew Parsons <dparsons@debian.org>  Sat, 29 Aug 2020 14:05:11 +0800

dolfin (2019.2.0~git20200218.027d9cc-14) unstable; urgency=medium

  * add debian patch test_floating_point.patch to use pytest.approx to
    test equality of floating point numbers (in geometry/test_point.py)
    Needed to pass non-intel (arm64, ppc64el) tests.

 -- Drew Parsons <dparsons@debian.org>  Mon, 10 Aug 2020 14:52:01 +0800

dolfin (2019.2.0~git20200218.027d9cc-13) unstable; urgency=medium

  * disable dolfin64 tests in debian/tests (autopkgtest).
    They are known to fail. Reinstate once they are passing.
  * mark libdolfin-dev, libdolfin64-dev as Multi-Arch: same
  * mark libdolfin-dev-common Architecture: all and Multi-Arch: foreign
  * remove FindEigen3.cmake from FindMPFR.cmake entry in debian/copyright
  * debhelper compatibility level 13

 -- Drew Parsons <dparsons@debian.org>  Sun, 09 Aug 2020 22:10:12 +0800

dolfin (2019.2.0~git20200218.027d9cc-12) unstable; urgency=medium

  * add mipsel to 32-bit arch list skipping some 64-bit tests,
    including demo_contact-vi-snes_serial, demo_sym-dirichlet-bc_serial

 -- Drew Parsons <dparsons@debian.org>  Mon, 20 Jul 2020 15:05:17 +0800

dolfin (2019.2.0~git20200218.027d9cc-11) experimental; urgency=medium

  * skip demo_contact-vi-snes_serial in 64-bit tests on armel, armhf

 -- Drew Parsons <dparsons@debian.org>  Sat, 18 Jul 2020 09:19:12 +0800

dolfin (2019.2.0~git20200218.027d9cc-10) experimental; urgency=medium

  * update list of 64-bit tests skipped on 32-bit arches:
      demo_mixed-poisson_serial
      demo_stokes-taylor-hood_serial
      demo_auto-adaptive-navier-stokes_serial
      demo_multimesh-stokes_serial

 -- Drew Parsons <dparsons@debian.org>  Fri, 17 Jul 2020 12:33:07 +0800

dolfin (2019.2.0~git20200218.027d9cc-9) experimental; urgency=medium

  * append 64-bit tests to skip on 32-bit arches, append to
    ARCH_SPECIFIC_SKIP_SERIAL_TEST_64
  * libdolfin-dev-common Replaces and Breaks:
    libdolfin-dev (<< 2019.2.0~git20200218.027d9cc-7)
    Add corresponding versioned depends for libdolfin-dev on
    libdolfin-dev-common (>= 2019.2.0~git20200218.027d9cc-7)
    Closes: #965005.

 -- Drew Parsons <dparsons@debian.org>  Tue, 14 Jul 2020 23:34:19 +0800

dolfin (2019.2.0~git20200218.027d9cc-8) experimental; urgency=medium

  * skip 64-bit build-time tests of
      demo_mixed-poisson_serial
      demo_stokes-taylor-hood_serial
      demo_contact-vi-snes_serial
      demo_multimesh-stokes_serial
    on 32 bit arches (armel armhf i386 hppa m68k powerpc)

 -- Drew Parsons <dparsons@debian.org>  Tue, 14 Jul 2020 11:47:03 +0800

dolfin (2019.2.0~git20200218.027d9cc-7) experimental; urgency=medium

  * new packages libdolfin64-dev, python3-dolfin64-real provide DOLFIN
    built against 64-bit PETSc (64-bit indexing). Set
    PETSC_DIR=/usr/lib/petsc64 SLEPC_DIR=/usr/lib/slepc64 to activate.
    - skip 64-bit build-time serial tests demo_stokes-iterative_serial
      and demo_curl-curl_serial
    - ignore errors in 64-bit MPI tests:
      "PETSc function 'KSPSolve' error code: 92 (See petsc
      linearsolvertable.html for possible LU and Cholesky solvers)
  * convert python3-dolfin to a base package providing dolfin.pth that
    Recommends: python3-dolfin-real. PETSc-specific dolfin module is
    installed under the PETSC_DIR it was built against and made
    accessible via dolfin.pth.
  * add debian patches
    - lib_rename.patch allows LIB_NAME_EXT to be defined as a suffix
      to the library name, to distinguish libdolfin.so from
      libdolfin64.so
    - cmake_find_petsc.patch ensures PETSc is found before loading
      Dolfin cmake rules (needed to check for 64-bit build)

 -- Drew Parsons <dparsons@debian.org>  Tue, 07 Jul 2020 16:27:09 +0800

dolfin (2019.2.0~git20200218.027d9cc-6) unstable; urgency=medium

  * dolfin-doc provides HTML documentation (Python and C++ API)
    - include .rst files (sphinx html docs references them in
      "View page source" links)

 -- Drew Parsons <dparsons@debian.org>  Mon, 27 Apr 2020 18:27:50 +0800

dolfin (2019.2.0~git20200218.027d9cc-5) unstable; urgency=medium

  * include mesh files in upload:
    git lfs pull; patch -p1 -R <debian/patches/git-lfs_fetch_demo_meshes

 -- Drew Parsons <dparsons@debian.org>  Mon, 20 Apr 2020 22:07:47 +0800

dolfin (2019.2.0~git20200218.027d9cc-4) unstable; urgency=medium

  * upload Cécile Daversin-Catty's snapshot to unstable

 -- Drew Parsons <dparsons@debian.org>  Mon, 20 Apr 2020 17:46:09 +0800

dolfin (2019.2.0~git20200218.027d9cc-3) experimental; urgency=medium



=== debian/control ===
Source: dolfin
Section: math
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Johannes Ring <johannr@simula.no>,
 Drew Parsons <dparsons@debian.org>
Build-Depends:
 cmake (>= 3.5),
 debhelper-compat (= 13),
 dh-python,
 gfortran,
 chrpath,
 libboost-chrono-dev,
 libboost-dev (>= 1.56),
 libboost-filesystem-dev,
 libboost-iostreams-dev,
 libboost-math-dev,
 libboost-mpi-dev,
 libboost-program-options-dev,
 libboost-serialization-dev,
 libboost-thread-dev,
 libboost-timer-dev,
 libeigen3-dev (>= 3.2.90),
 libhdf5-mpi-dev,
 libsuitesparse-dev,
 libscotch-dev,
 libxml2-dev,
 mpi-default-dev,
 petsc-dev (>= 3.7),
 slepc-dev (>= 3.7),
 python3-petsc4py-real,
 python3-slepc4py-real,
 petsc64-dev (>= 3.7),
 slepc64-dev (>= 3.7),
 python3-petsc4py-64-real,
 python3-slepc4py-64-real,
 pybind11-dev (>= 2.2.0),
 python3-setuptools,
 pkg-config,
 python3-all-dev,
 python3-pkg-resources,
 python3-ffc (>= 2019.2), python3-ffc (<< 2019.3),
 python3-dijitso (>= 2019.2), python3-dijitso (<< 2019.3),
 python3-numpy,
 python3-ply,
 python3-sphinx,
 python3-sphinx-rtd-theme,
 doxygen,
 libjs-mathjax,
 libjs-modernizr
Standards-Version: 4.5.0
Homepage: http://fenicsproject.org
Vcs-Git: https://salsa.debian.org/science-team/fenics/dolfin.git
Vcs-Browser: https://salsa.debian.org/science-team/fenics/dolfin

Package: libdolfin-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libdolfin-dev-common (>= 2019.2.0~git20200218.027d9cc-7),
 cmake (>= 2.8.0),
 g++ | c++-compiler,
 libboost-chrono-dev,
 libboost-dev,
 libboost-filesystem-dev,
 libboost-iostreams-dev,
 libboost-math-dev,
 libboost-mpi-dev,
 libboost-program-options-dev,
 libboost-serialization-dev,
 libboost-thread-dev,
 libboost-timer-dev,
 libdolfin2019.2 (= ${binary:Version}),
 libeigen3-dev,
 libhdf5-mpi-dev,
 libsuitesparse-dev,
 libscotch-dev,
 libxml2-dev,
 pkg-config,
 python3-ffc (>= ${fenics:Upstream-Version}), python3-ffc (<< ${fenics:Next-Upstream-Version}),
 ${petsc:Depends},
 ${misc:Depends}
Conflicts:
 libdolfin0-dev,
 libdolfin1.0-dev,
 libdolfin1.1-dev,
 libdolfin1.2-dev,
 libdolfin1.3-dev,
 libdolfin1.4-dev
Replaces:
 libdolfin0-dev,
 libdolfin1.0-dev,
 libdolfin1.1-dev,
 libdolfin1.2-dev,
 libdolfin1.3-dev,
 libdolfin1.4-dev
Description: Shared links and development files for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the development files.
 .
 This is the legacy version of DOLFIN, you may want to install the
 next-generation libdolfinx-dev (DOLFIN-X) instead.

Package: libdolfin-dev-common
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends}
Conflicts:
 libdolfin0-dev,
 libdolfin1.0-dev,
 libdolfin1.1-dev,
 libdolfin1.2-dev,
 libdolfin1.3-dev,
 libdolfin1.4-dev
Replaces:
 libdolfin0-dev,
 libdolfin1.0-dev,
 libdolfin1.1-dev,
 libdolfin1.2-dev,
 libdolfin1.3-dev,
 libdolfin1.4-dev,
 libdolfin-dev (<< 2019.2.0~git20200218.027d9cc-7)
Breaks:
 libdolfin-dev (<< 2019.2.0~git20200218.027d9cc-7)
Description: Common header files for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the common development header files.
 .
 This is the legacy version of DOLFIN, you may want to install the
 next-generation libdolfinx-dev (DOLFIN-X) instead.

Package: libdolfin2019.2
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: dolfin-doc, python3-dolfin
Description: Shared libraries for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the shared libraries.

Package: python3-dolfin
Section: python
Architecture: any
Depends: python3-dolfin-real | python3-dolfin64-real,
 python3-dijitso (>= ${fenics:Upstream-Version}), python3-dijitso (<< ${fenics:Next-Upstream-Version}),
 python3-ffc (>= ${fenics:Upstream-Version}), python3-ffc (<< ${fenics:Next-Upstream-Version}),
 python3-ufl (>= ${fenics:Upstream-Version}), python3-ufl (<< ${fenics:Next-Upstream-Version}),
 python3-numpy,
 python3-ply,
 python3-pybind11 (>= ${pybind11:Upstream-Version}), python3-pybind11 (<< ${pybind11:Next-Upstream-Version}),
 python3-six,
 python3-sympy,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends}
Suggests: dolfin-doc
Description: Base Python interface for DOLFIN (Python 3)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This is the base package depending on specific dolfin builds. By
 default the version built against the preferred version of PETSc in
 /usr/lib/petsc is selected (with 32-bit indexing, but the
 alternative version (64-bit PETSc) can be selected by setting the
 environment variable PETSC_DIR.
 .
 This is the legacy version of DOLFIN, you may want to install the
 next-generation python3-dolfinx (DOLFIN-X) instead.

Package: python3-dolfin-real
Section: python
Architecture: any
Depends:
 libdolfin-dev (= ${binary:Version}),
 libdolfin2019.2 (= ${binary:Version}),
 ${python3-petsc4py:Depends},
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends}
Recommends: python3-dolfin (= ${binary:Version})
Description: Python interface for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the Python interface for DOLFIN (Python 3)
 build against the default version of PETSc (with 32-bit indexing)
 .
 This is the legacy version of DOLFIN, you may want to install the
 next-generation python3-dolfinx (DOLFIN-X) instead.

Package: libdolfin64-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libdolfin-dev-common,
 cmake (>= 2.8.0),
 g++ | c++-compiler,
 libboost-chrono-dev,
 libboost-dev,
 libboost-filesystem-dev,
 libboost-iostreams-dev,
 libboost-math-dev,
 libboost-mpi-dev,
 libboost-program-options-dev,
 libboost-serialization-dev,
 libboost-thread-dev,
 libboost-timer-dev,
 libdolfin64-2019.2 (= ${binary:Version}),
 libeigen3-dev,
 libhdf5-mpi-dev,
 libsuitesparse-dev,
 libscotch-dev,
 libxml2-dev,
 pkg-config,
 python3-ffc (>= ${fenics:Upstream-Version}), python3-ffc (<< ${fenics:Next-Upstream-Version}),
 ${petsc64:Depends},
 ${misc:Depends}
Description: Shared links and dev files for DOLFIN (64-bit indexing)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the development files for DOLFIN built against
 64-bit PETSc (64-bit indexing).
 .
 This is the legacy version of DOLFIN, you may want to install the
 next-generation libdolfinx-dev (DOLFIN-X) instead.

Package: libdolfin64-2019.2
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: dolfin-doc, python3-dolfin64-real
Description: Shared libraries for DOLFIN (64-bit indexing)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the shared libraries for DOLFIN built against
 64-bit PETSc (64-bit indexing).

Package: python3-dolfin64-real
Section: python
Architecture: any
Depends:
 libdolfin64-dev (= ${binary:Version}),
 libdolfin64-2019.2 (= ${binary:Version}),
 ${python3-petsc4py-64:Depends},
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends}
Recommends: python3-dolfin (= ${binary:Version})
Description: Python interface for DOLFIN (with 64-bit PETSc integers)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the Python interface for DOLFIN (Python 3)
 build against 64-bit PETSc (64-bit indexing)
 .
 This is the legacy version of DOLFIN, you may want to install the
 next-generation python3-dolfinx (DOLFIN-X) instead.

Package: dolfin-doc
Architecture: all
Section: doc
Depends:
 libdolfin-dev (>= ${source:Version}),
 python3-dolfin (>= ${source:Version}),
 ${misc:Depends},
 ${sphinxdoc:Depends}
Recommends: python3-matplotlib
Suggests: cmake (>= 2.8.0)
Description: Documentation and demo programs for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains documentation and demo programs for DOLFIN.

Package: dolfin-bin
Architecture: all
Depends:
 python3-dolfin (>= ${source:Version}),
 ${misc:Depends},
 ${python3:Depends}
Description: Executable scripts for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

DEB_SOURCE_PACKAGE := $(strip $(shell egrep '^Source: ' debian/control | cut -f 2 -d ':'))
DEB_VERSION := $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
DEB_NOEPOCH_VERSION := $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION := $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')
DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -e 's/\+dfsg.*$$//p')

FENICS_RELEASE_VERSION=$(DEB_STRIPPED_UPSTREAM_VERSION)
FENICS_MAJOR_VERSION=$(shell echo $(FENICS_RELEASE_VERSION) | sed "s/^\([^.]*\)\..*$$/\1/")
FENICS_MINOR_VERSION=$(shell echo $(FENICS_RELEASE_VERSION) | sed "s/^\([^.]*\)\.\([^.]*\)\..*$$/\2/")
FENICS_VERSION=$(FENICS_MAJOR_VERSION).$(FENICS_MINOR_VERSION)
FENICS_NEXT_VERSION=$(FENICS_MAJOR_VERSION).$(shell echo $$(( $(FENICS_MINOR_VERSION) + 1 )) )

# dolfin depends on the pybind11 version it was built against,
# if pybind11.h will be used in C++ code fragments in python scripts.
# But pybind11 follows semantic versioning, so should have backwards compatibility
# with minor and patch version updates.
# Extract pybind11 version from pybind11-dev
PYBIND11_DEB_VERSION=$(shell dpkg -s pybind11-dev | awk '/Version:/ {print $$2}')
# extract the current pybind11 version X.Y.Z (drop epoch and debian package version)
PYBIND11_UPSTREAM_VERSION=$(shell echo $(PYBIND11_DEB_VERSION) | sed "s/^.[^:]*://; s/-[^-]*$$//")
PYBIND11_X_VERSION=$(shell echo $(PYBIND11_UPSTREAM_VERSION) | sed "s/^\([^.]*\).*/\1/")
PYBIND11_X_Y_VERSION=$(shell echo $(PYBIND11_UPSTREAM_VERSION) | sed "s/^\(.*\)\.\([^.]*\)$$/\1/")
PYBIND11_VERSION=$(PYBIND11_X_Y_VERSION)
PYBIND11_NEXT_VERSION=$(shell echo $$(( $(PYBIND11_X_VERSION) + 1 )) )

# Allow test programs that use OpenMPI to run
export OMPI_MCA_plm_rsh_agent=/bin/false
export OMPI_MCA_btl_base_warn_component_unused=0

include /usr/share/mpi-default-dev/debian_defaults
ENABLE_MPI=ON
ifeq ($(findstring $(DEB_BUILD_ARCH),$(OPENMPI_ARCHITECTURES)),)
MPIEXEC_PARAMS=
else
MPIEXEC_PARAMS=--oversubscribe
endif

DOLFIN_HOME = $(CURDIR)/$(DEB_SRCDIR)
USCAN_DESTDIR := $(CURDIR)
PY3VERS := $(shell py3versions --requested debian/control | tac -s' ')
PYVERS = $(PY3VERS)

BUILDDIR = obj-$(DEB_HOST_GNU_TYPE)
BUILDDIR_64 = obj-$(DEB_HOST_GNU_TYPE)-64
TESTDIR = build-tests
TESTDIR_64 = build-tests-64

NPROC := $(shell nproc)
PARALLEL = $(subst parallel=,,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
N_CPU    = $(or $(PARALLEL),$(NPROC),1)
# MPI tests are set up to run on 3 processes. Spread them leanly over the available processors (don't have more than 2 tests using one processor).
# e.g. run 1 MPI test at a time over 1-3 processors, or 2 tests at a time over 4-6 processors, or 3 tests over 7-9 processors, etc.
N_MPI := 3
N_MPI_TESTS = $(shell echo $$(( ($(N_CPU)+$(N_MPI)-1)/$(N_MPI) )) )

# hyperelasticity fails (diverges) on all arches (pivot factors too large, not enough memory assigned)
# elastodynamics passes with dpkg-buildpackage but fails with pdebuild (on amd64). Unreliable, so skip.
ARCH_ALL_SKIP_MPI_TEST = demo_hyperelasticity_mpi demo_elastodynamics_mpi

# Some arches fail the same MPI tests
# e.g. cahn-hilliard, navier-stokes, elasticity, fails or exceeds allowed time
# So skip these tests on the failing arches
ARCH_SKIP_MPI_TEST_LIST = i386 ppc64el ia64
ARCH_SKIP_MPI_TEST = demo_cahn-hilliard_mpi demo_navier-stokes_mpi demo_elasticity_mpi

# skip more MPI tests for some specific arches
ifeq (arm64, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_navier-stokes_mpi
else ifeq (mips, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_cahn-hilliard_mpi demo_stokes-iterative_mpi demo_ale_mpi demo_poisson-disc_mpi
else ifeq (mipsel, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_cahn-hilliard_mpi demo_stokes-iterative_mpi demo_ale_mpi demo_poisson-disc_mpi
else ifeq (ppc64el, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_poisson_mpi demo_singular-poisson_mpi demo_sym-dirichlet-bc_mpi
else ifeq (ia64, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_bcs_mpi demo_biharmonic_mpi demo_built-in-meshes_mpi demo_eigenvalue_mpi
else ifeq (sparc64, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_contact-vi-snes_mpi
else
  ARCH_SPECIFIC_SKIP_MPI_TEST =
endif

# m68k,mips,sparc64 need some help to pass serial tests
ifeq (m68k, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_SERIAL_TEST = demo_auto-adaptive-poisson_serial demo_elasticity_serial
else ifeq (mips, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_SERIAL_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial
else ifeq (sparc64, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_SERIAL_TEST = demo_contact-vi-snes_serial
else
  ARCH_SPECIFIC_SKIP_SERIAL_TEST =
endif


# skip slow tests (> 500-1000 sec to complete)
ifeq (armel, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_stokes-iterative_serial demo_auto-adaptive-navier-stokes_serial demo_hyperelasticity_serial demo_cahn-hilliard_serial
else ifeq (mips, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_eigenvalue_serial demo_navier-stokes_serial demo_auto-adaptive-poisson_serial demo_stokes-taylor-hood_serial demo_auto-adaptive-navier-stokes_serial demo_curl-curl_serial demo_elasticity_serial demo_stokes-iterative_serial demo_eval_serial demo_sym-dirichlet-bc_serial demo_elastodynamics_serial demo_eigenvalue_mpi demo_navier-stokes_mpi demo_curl-curl_mpi demo_elasticity_mpi demo_elastodynamics_mpi demo_sym-dirichlet-bc_mpi
else ifeq (mipsel, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial
else ifeq (hppa, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial
else ifeq (m68k, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial
else ifeq (riscv64, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial demo_cahn-hilliard_mpi demo_elastodynamics_mpi
else ifeq (sparc64, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial demo_stokes-iterative_serial demo_cahn-hilliard_mpi demo_elastodynamics_mpi
else
  ARCH_SKIP_SLOW_TEST =
endif

empty :=
space := $(empty)$(empty)

ARCH32_LIST = armel armhf i386 mipsel powerpc x32

ARCH_SPECIFIC_SKIP_SERIAL_TEST_64 = $(ARCH_SPECIFIC_SKIP_SERIAL_TEST) demo_stokes-iterative_serial demo_curl-curl_serial
ARCH_SPECIFIC_SKIP_MPI_TEST_64 = $(ARCH_SPECIFIC_SKIP_MPI_TEST)

ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(ARCH32_LIST)$(space)))
  # these 4 tests fail in 64-bit build tests on 32-bit arches
  ARCH_SPECIFIC_SKIP_SERIAL_TEST_64 += demo_mixed-poisson_serial demo_stokes-taylor-hood_serial demo_auto-adaptive-navier-stokes_serial demo_multimesh-stokes_serial
endif
ifeq (armel, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_SERIAL_TEST_64 += demo_contact-vi-snes_serial
else ifeq (armhf, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_SERIAL_TEST_64 += demo_contact-vi-snes_serial
else ifeq (mipsel, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_SERIAL_TEST_64 += demo_contact-vi-snes_serial demo_sym-dirichlet-bc_serial
endif

# other arches fail or time out on too many tests, so skip all their MPI tests
ARCH_SKIP_ALL_MPI_TESTS_LIST=armel armhf i386 hppa m68k powerpc

# some arches just aren't keeping up at all, and fail non-MPI tests
ARCH_SKIP_ALL_TESTS_LIST = mips64el hurd-i386 m68k sh4

# extract PETSc version from petsc-dev
PETSC_DEB_VERSION=$(shell dpkg -s petsc-dev | awk '/Version:/ {print $2}')
# extract the current PETSc version
PETSC_UPSTREAM_VERSION=$(shell pkg-config --modversion PETSc)
# "Major" version is the first number in the upstream version (major.minor.release)
PETSC_MAJOR_VERSION=$(shell echo $(PETSC_UPSTREAM_VERSION) | sed "s/^\([^.]*\)\..*$$/\1/")
# "Minor" version is the second number in the upstream version (major.minor.release)
PETSC_MINOR_VERSION=$(shell echo $(PETSC_UPSTREAM_VERSION) | sed "s/^\([^.]*\)\.\([^.]*\)\..*$$/\2/")

=== debian/tests/control ===
Tests: test-dolfin-cpp, test-dolfin-python,
# test-dolfin64-cpp, test-dolfin64-python
Depends: @, @builddeps@,
	  python3-pytest,
	  python3-decorator,
	  python3-matplotlib,
	  python3-scipy

## dolfin 2019.2.0~git20200629.946dbd3+lfs

=== debian/changelog ===
dolfin (2019.2.0~git20200629.946dbd3+lfs-4) unstable; urgency=medium

  * Team upload.
  * [7286d2a] Fix FTBFS. (Closes: #977222)
  * [47cdea3] Ignore quilt dir
  * [c8d8285] Remove unused patch
  * [8e0289b] Trim trailing whitespace.
  * [a251c1d] Use secure copyright file specification URI.
  * [c6c315f] debian/copyright: use spaces rather than tabs to start
              continuation lines.
  * [327629b] Remove unnecessary get-orig-source-target.
  * [615ba90] Drop transition for old debug package migration.
  * [d47166b] Respect CPPFLAGS

 -- Anton Gladky <gladk@debian.org>  Tue, 15 Dec 2020 22:52:05 +0100

dolfin (2019.2.0~git20200629.946dbd3+lfs-3) unstable; urgency=medium

  * debian/tests: run C++ tests with Restrictions: allow-stderr
    to ignore compilation warnings (which are sent to stderr)
  * debian/tests: skip more python demos (iterative, block, meshview,
    assignment) on i386, armhf

 -- Drew Parsons <dparsons@debian.org>  Tue, 24 Nov 2020 03:46:18 +0800

dolfin (2019.2.0~git20200629.946dbd3+lfs-2) unstable; urgency=medium

  * debian/tests Depends: libblis-pthread-dev | libopenblas-pthread-dev
    (intention is to improve debci test times)
  * skip slow python demos (cahn-hilliard hyperelasticity
    elastodynamics navier-stokes elasticity) in debian/tests
  * debian patch demo_block-assembly-3D2D_relax.patch relaxes
    tolerance in 3D vector check.

 -- Drew Parsons <dparsons@debian.org>  Mon, 23 Nov 2020 02:13:28 +0800

dolfin (2019.2.0~git20200629.946dbd3+lfs-1) unstable; urgency=medium

  * reset against upstream source containing lfs demo files
    (git archive from local clone instead of bitbucket download link)
   - drop debian patch git-lfs_fetch_demo_meshes and remove upstream
     source entries from debian/source/include-binaries
  * debian/tests: split python unit tests from python demos
  * Standards-Version: 4.5.1

 -- Drew Parsons <dparsons@debian.org>  Sat, 21 Nov 2020 20:29:06 +0800

dolfin (2019.2.0~git20200629.946dbd3-8) unstable; urgency=medium

  * [9f0767f] Fix compilation against Boost_1.74. (Closes: #974947)
  * Proper source-only upload with demo-files. (Closes: #975057)

 -- Anton Gladky <gladk@debian.org>  Wed, 18 Nov 2020 17:09:19 +0100

dolfin (2019.2.0~git20200629.946dbd3-7) unstable; urgency=medium

  * Team upload.
  * [004980a] Revert "Fix compilation against Boost_1.74. (Closes: #975012)"

 -- Anton Gladky <gladk@debian.org>  Tue, 17 Nov 2020 23:03:48 +0100

dolfin (2019.2.0~git20200629.946dbd3-6) unstable; urgency=medium

  * Team upload.
  * [9726492] Fix compilation against Boost_1.74. (Closes: #974948)

 -- Anton Gladky <gladk@debian.org>  Tue, 17 Nov 2020 18:03:48 +0100

dolfin (2019.2.0~git20200629.946dbd3-5) unstable; urgency=medium

  * Use -flto-partition=none on mips64el. Thanks Adrian Bunk.
    Drop debian patch pybind11_lto_mips64el.patch.
  * Build-Depends: graphviz to provide dot for building docs.
  * Build-Depends: python3-petsc4py, python3-slepc4py to provide .pth

 -- Drew Parsons <dparsons@debian.org>  Sun, 15 Nov 2020 01:18:39 +0800

dolfin (2019.2.0~git20200629.946dbd3-4) unstable; urgency=medium

  * skip slow serial tests on armel, armhf, alpha, riscv64
  * skip demo_cahn-hilliard_serial on all arches (everywhere slow)

 -- Drew Parsons <dparsons@debian.org>  Mon, 09 Nov 2020 12:37:51 +0800

dolfin (2019.2.0~git20200629.946dbd3-3) unstable; urgency=medium

  * debian patch test_float128.patch runs unit/la/test_vector.py using
    numpy.longdouble instead of numpy.float128 on systems (32-bit arches)
    which do not support numpy.float128

 -- Drew Parsons <dparsons@debian.org>  Mon, 12 Oct 2020 01:08:21 +0800

dolfin (2019.2.0~git20200629.946dbd3-2) unstable; urgency=medium

  * python3-dolfin Depends: python3-petsc4py, python3-slepc4py
    (make sure base packages are available providing .pth files)

 -- Drew Parsons <dparsons@debian.org>  Sun, 06 Sep 2020 23:18:53 +0800

=== debian/rules ===
--- 
+++ 
@@ -57,6 +57,9 @@
 N_MPI := 3
 N_MPI_TESTS = $(shell echo $$(( ($(N_CPU)+$(N_MPI)-1)/$(N_MPI) )) )
 
+# some tests run slow (> 1000 sec) on all arches
+ARCH_ALL_SKIP_SERIAL_TEST = demo_hyperelasticity_serial demo_cahn-hilliard_serial
+
 # hyperelasticity fails (diverges) on all arches (pivot factors too large, not enough memory assigned)
 # elastodynamics passes with dpkg-buildpackage but fails with pdebuild (on amd64). Unreliable, so skip.
 ARCH_ALL_SKIP_MPI_TEST = demo_hyperelasticity_mpi demo_elastodynamics_mpi
@@ -98,17 +101,21 @@
 
 # skip slow tests (> 500-1000 sec to complete)
 ifeq (armel, $(DEB_HOST_ARCH))
-  ARCH_SKIP_SLOW_TEST = demo_stokes-iterative_serial demo_auto-adaptive-navier-stokes_serial demo_hyperelasticity_serial demo_cahn-hilliard_serial
+  ARCH_SKIP_SLOW_TEST = demo_stokes-iterative_serial demo_auto-adaptive-navier-stokes_serial demo_elastodynamics_serial demo_sym-dirichlet-bc_serial demo_hyperelasticity_serial demo_cahn-hilliard_serial
+else ifeq (armhf, $(DEB_HOST_ARCH))
+  ARCH_SKIP_SLOW_TEST = demo_elastodynamics_serial demo_sym-dirichlet-bc_serial demo_hyperelasticity_serial
 else ifeq (mips, $(DEB_HOST_ARCH))
   ARCH_SKIP_SLOW_TEST = demo_eigenvalue_serial demo_navier-stokes_serial demo_auto-adaptive-poisson_serial demo_stokes-taylor-hood_serial demo_auto-adaptive-navier-stokes_serial demo_curl-curl_serial demo_elasticity_serial demo_stokes-iterative_serial demo_eval_serial demo_sym-dirichlet-bc_serial demo_elastodynamics_serial demo_eigenvalue_mpi demo_navier-stokes_mpi demo_curl-curl_mpi demo_elasticity_mpi demo_elastodynamics_mpi demo_sym-dirichlet-bc_mpi
 else ifeq (mipsel, $(DEB_HOST_ARCH))
   ARCH_SKIP_SLOW_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial
+else ifeq (alpha, $(DEB_HOST_ARCH))
+  ARCH_SKIP_SLOW_TEST = demo_elastodynamics_serial demo_sym-dirichlet-bc_serial demo_hyperelasticity_serial
 else ifeq (hppa, $(DEB_HOST_ARCH))
   ARCH_SKIP_SLOW_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial
 else ifeq (m68k, $(DEB_HOST_ARCH))
   ARCH_SKIP_SLOW_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial
 else ifeq (riscv64, $(DEB_HOST_ARCH))
-  ARCH_SKIP_SLOW_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial demo_cahn-hilliard_mpi demo_elastodynamics_mpi
+  ARCH_SKIP_SLOW_TEST = demo_elastodynamics_serial demo_sym-dirichlet-bc_serial demo_cahn-hilliard_serial demo_hyperelasticity_serial demo_cahn-hilliard_mpi demo_elastodynamics_mpi
 else ifeq (sparc64, $(DEB_HOST_ARCH))
   ARCH_SKIP_SLOW_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial demo_stokes-iterative_serial demo_cahn-hilliard_mpi demo_elastodynamics_mpi
 else
@@ -142,10 +149,3 @@
 ARCH_SKIP_ALL_TESTS_LIST = mips64el hurd-i386 m68k sh4
 
 # extract PETSc version from petsc-dev
-PETSC_DEB_VERSION=$(shell dpkg -s petsc-dev | awk '/Version:/ {print $2}')
-# extract the current PETSc version
-PETSC_UPSTREAM_VERSION=$(shell pkg-config --modversion PETSc)
-# "Major" version is the first number in the upstream version (major.minor.release)
-PETSC_MAJOR_VERSION=$(shell echo $(PETSC_UPSTREAM_VERSION) | sed "s/^\([^.]*\)\..*$$/\1/")
-# "Minor" version is the second number in the upstream version (major.minor.release)
-PETSC_MINOR_VERSION=$(shell echo $(PETSC_UPSTREAM_VERSION) | sed "s/^\([^.]*\)\.\([^.]*\)\..*$$/\2/")

## dolfin 2019.2.0~git20201207.b495043

=== CMakeLists.txt ===
project(dolfin-demos)

# Require CMake 2.8
cmake_minimum_required(VERSION 3.5)

# Find DOLFIN config file (not used here, but check that the demo will
# be able to find it
#find_package(DOLFIN PATHS ${CMAKE_BINARY_DIR} REQUIRED)
include_directories(${DOLFIN_SOURCE_DIR} ${DOLFIN_SOURCE_DIR}/dolfin ${DOLFIN_BINARY_DIR})

# Documented demos
add_subdirectory(documented/auto-adaptive-poisson/cpp)
add_subdirectory(documented/bcs/cpp)
add_subdirectory(documented/biharmonic/cpp)
add_subdirectory(documented/built-in-meshes/cpp)
add_subdirectory(documented/cahn-hilliard/cpp)
add_subdirectory(documented/eigenvalue/cpp)
add_subdirectory(documented/hyperelasticity/cpp)
add_subdirectory(documented/mixed-poisson/cpp)
add_subdirectory(documented/navier-stokes/cpp)
add_subdirectory(documented/neumann-poisson/cpp)
add_subdirectory(documented/nonlinear-poisson/cpp)
add_subdirectory(documented/nonmatching-interpolation/cpp)
add_subdirectory(documented/periodic/cpp)
add_subdirectory(documented/poisson/cpp)
add_subdirectory(documented/singular-poisson/cpp)
add_subdirectory(documented/stokes-iterative/cpp)
add_subdirectory(documented/stokes-taylor-hood/cpp)
add_subdirectory(documented/subdomains/cpp)

# Undocumented demos
add_subdirectory(undocumented/advection-diffusion/cpp)
add_subdirectory(undocumented/ale/cpp)
add_subdirectory(undocumented/auto-adaptive-navier-stokes/cpp)
add_subdirectory(undocumented/block-matrix/cpp)
add_subdirectory(undocumented/conditional/cpp)
add_subdirectory(undocumented/contact-vi-snes/cpp)
add_subdirectory(undocumented/contact-vi-tao/cpp)
add_subdirectory(undocumented/curl-curl/cpp)
add_subdirectory(undocumented/dg-advection-diffusion/cpp)
add_subdirectory(undocumented/dg-poisson/cpp)
add_subdirectory(undocumented/elasticity/cpp)
add_subdirectory(undocumented/elastodynamics/cpp)
add_subdirectory(undocumented/eval/cpp)
add_subdirectory(undocumented/extrapolation/cpp)
add_subdirectory(undocumented/functional/cpp)
add_subdirectory(undocumented/gmg-poisson/cpp)
add_subdirectory(undocumented/lift-drag/cpp)
add_subdirectory(undocumented/mesh-quality/cpp)
add_subdirectory(undocumented/meshfunction-refinement/cpp)
add_subdirectory(undocumented/multimesh-poisson/cpp)
add_subdirectory(undocumented/multimesh-stokes/cpp)
add_subdirectory(undocumented/nonmatching-projection/cpp)
add_subdirectory(undocumented/parallel-refinement/cpp)
add_subdirectory(undocumented/parameters/cpp)
add_subdirectory(undocumented/poisson1D/cpp)
add_subdirectory(undocumented/poisson1D-in-2D/cpp)
add_subdirectory(undocumented/poisson-disc/cpp)
add_subdirectory(undocumented/refinement/cpp)
add_subdirectory(undocumented/spatial-coordinates/cpp)
add_subdirectory(undocumented/submesh/cpp)
add_subdirectory(undocumented/sym-dirichlet-bc/cpp)
add_subdirectory(undocumented/time-series/cpp)
add_subdirectory(undocumented/waveguide/cpp)

=== common/CMakeLists.txt ===
set(HEADERS
  Array.h
  ArrayView.h
  constants.h
  defines.h
  dolfin_common.h
  dolfin_doc.h
  Hierarchical.h
  IndexSet.h
  init.h
  MPI.h
  NoDeleter.h
  RangedIndexSet.h
  Set.h
  SubSystemsManager.h
  Timer.h
  timing.h
  types.h
  UniqueIdGenerator.h
  utils.h
  Variable.h
  PARENT_SCOPE)

set(SOURCES
  defines.cpp
  init.cpp
  MPI.cpp
  SubSystemsManager.cpp
  Timer.cpp
  timing.cpp
  UniqueIdGenerator.cpp
  utils.cpp
  Variable.cpp
  PARENT_SCOPE)

=== debian/changelog ===
dolfin (2019.2.0~git20201207.b495043-5) unstable; urgency=medium

  * use triple-slash (file:///) for mathjax local url replacement to
    make docs for demos properly legible.

 -- Drew Parsons <dparsons@debian.org>  Wed, 09 Jun 2021 13:23:16 +0200

dolfin (2019.2.0~git20201207.b495043-4) unstable; urgency=medium

  * debian/tests: add ppc64el to the list of arches skipping some tests
  * update test_relax_tolerance.patch to relax more tolerances in
    multimesh/test_volume.py for ppc64el.

 -- Drew Parsons <dparsons@debian.org>  Fri, 29 Jan 2021 17:09:57 +0100

dolfin (2019.2.0~git20201207.b495043-3) unstable; urgency=medium

  * skip failing mesh and multimesh tests on selected non-amd64 arches
    (arm64, i386, s390x)
  * update test_relax_tolerance.patch to relax multimesh test
    tolerances
  * display timings of 20 slowest python unit tests and demos

 -- Drew Parsons <dparsons@debian.org>  Thu, 28 Jan 2021 11:40:28 +0100

dolfin (2019.2.0~git20201207.b495043-2) unstable; urgency=medium

  * add mipsel to the list of arches which fail MPI demo tests or run
    too slowly.
  * debian patch test_relax_tolerance.patch relaxes tolerance in
    test_incremental_assembly in unit/fem/test_system_assembler.py
  * apply "set -e" in debian/tests to register test failures

 -- Drew Parsons <dparsons@debian.org>  Wed, 27 Jan 2021 19:59:23 +0100

dolfin (2019.2.0~git20201207.b495043-1) unstable; urgency=medium

  * New upstream snapshot.

 -- Drew Parsons <dparsons@debian.org>  Mon, 25 Jan 2021 16:48:33 +0100

=== debian/control ===
--- 
+++ 
@@ -29,6 +29,8 @@
  mpi-default-dev,
  petsc-dev (>= 3.7),
  slepc-dev (>= 3.7),
+ python3-petsc4py,
+ python3-slepc4py,
  python3-petsc4py-real,
  python3-slepc4py-real,
  petsc64-dev (>= 3.7),
@@ -47,9 +49,10 @@
  python3-sphinx,
  python3-sphinx-rtd-theme,
  doxygen,
+ graphviz,
  libjs-mathjax,
  libjs-modernizr
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: http://fenicsproject.org
 Vcs-Git: https://salsa.debian.org/science-team/fenics/dolfin.git
 Vcs-Browser: https://salsa.debian.org/science-team/fenics/dolfin
@@ -172,6 +175,7 @@
  python3-ffc (>= ${fenics:Upstream-Version}), python3-ffc (<< ${fenics:Next-Upstream-Version}),
  python3-ufl (>= ${fenics:Upstream-Version}), python3-ufl (<< ${fenics:Next-Upstream-Version}),
  python3-numpy,
+ ${python3-petsc4py:Depends},
  python3-ply,
  python3-pybind11 (>= ${pybind11:Upstream-Version}), python3-pybind11 (<< ${pybind11:Next-Upstream-Version}),
  python3-six,
@@ -204,7 +208,7 @@
 Depends:
  libdolfin-dev (= ${binary:Version}),
  libdolfin2019.2 (= ${binary:Version}),
- ${python3-petsc4py:Depends},
+ ${python3-petsc4py-real:Depends},
  ${misc:Depends},
  ${python3:Depends},
  ${shlibs:Depends}
@@ -291,7 +295,7 @@
 Depends:
  libdolfin64-dev (= ${binary:Version}),
  libdolfin64-2019.2 (= ${binary:Version}),
- ${python3-petsc4py-64:Depends},
+ ${python3-petsc4py-64-real:Depends},
  ${misc:Depends},
  ${python3:Depends},
  ${shlibs:Depends}
@@ -339,4 +343,3 @@
  ${misc:Depends},
  ${python3:Depends}
 Description: Executable scripts for DOLFIN
- DOLFIN is the Python and C++ interface of the FEniCS project for the

=== debian/rules ===
--- 
+++ 
@@ -67,7 +67,7 @@
 # Some arches fail the same MPI tests
 # e.g. cahn-hilliard, navier-stokes, elasticity, fails or exceeds allowed time
 # So skip these tests on the failing arches
-ARCH_SKIP_MPI_TEST_LIST = i386 ppc64el ia64
+ARCH_SKIP_MPI_TEST_LIST = i386 mipsel ppc64el ia64
 ARCH_SKIP_MPI_TEST = demo_cahn-hilliard_mpi demo_navier-stokes_mpi demo_elasticity_mpi
 
 # skip more MPI tests for some specific arches
@@ -76,7 +76,7 @@
 else ifeq (mips, $(DEB_HOST_ARCH))
   ARCH_SPECIFIC_SKIP_MPI_TEST = demo_cahn-hilliard_mpi demo_stokes-iterative_mpi demo_ale_mpi demo_poisson-disc_mpi
 else ifeq (mipsel, $(DEB_HOST_ARCH))
-  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_cahn-hilliard_mpi demo_stokes-iterative_mpi demo_ale_mpi demo_poisson-disc_mpi
+  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_stokes-iterative_mpi demo_ale_mpi demo_poisson-disc_mpi
 else ifeq (ppc64el, $(DEB_HOST_ARCH))
   ARCH_SPECIFIC_SKIP_MPI_TEST = demo_poisson_mpi demo_singular-poisson_mpi demo_sym-dirichlet-bc_mpi
 else ifeq (ia64, $(DEB_HOST_ARCH))
@@ -92,6 +92,8 @@
   ARCH_SPECIFIC_SKIP_SERIAL_TEST = demo_auto-adaptive-poisson_serial demo_elasticity_serial
 else ifeq (mips, $(DEB_HOST_ARCH))
   ARCH_SPECIFIC_SKIP_SERIAL_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial
+else ifeq (mipsel, $(DEB_HOST_ARCH))
+  ARCH_SPECIFIC_SKIP_SERIAL_TEST = demo_elastodynamics_serial demo_sym-dirichlet-bc_serial
 else ifeq (sparc64, $(DEB_HOST_ARCH))
   ARCH_SPECIFIC_SKIP_SERIAL_TEST = demo_contact-vi-snes_serial
 else
@@ -146,6 +148,3 @@
 ARCH_SKIP_ALL_MPI_TESTS_LIST=armel armhf i386 hppa m68k powerpc
 
 # some arches just aren't keeping up at all, and fail non-MPI tests
-ARCH_SKIP_ALL_TESTS_LIST = mips64el hurd-i386 m68k sh4
-
-# extract PETSc version from petsc-dev
